#include <resources/alresource.h>

#include <stdlib.h>
#include <string.h>

ALResource al_resource_create(ALPath path)
{
    ALResource resource = malloc(sizeof(alyson_resource_t));
    resource->id = 0;
    memcpy(&resource->path, path, sizeof(alyson_path_t));

    return resource;
}

ALResource al_resource_create_from_file(char* name, char* path)
{
    ALResource resource = malloc(sizeof(alyson_resource_t));
    resource->id = 0;

    usx len = strlen(path);
    resource->path.path = malloc(sizeof(char) * (len + 1));
    memcpy(resource->path.path, path, sizeof(char) * len);
    resource->path.path[len] = '\0';

    memcpy(&resource->path.type, "res", 4);
    resource->path.type[4] = '\0';

    len = strlen(name);
    resource->path.name = malloc(sizeof(char) * len + 1);
    memcpy(resource->path.name, name, sizeof(char) * len);
    resource->path.name[len] = '\0';

    memcpy(&resource->path.group, "runtime", 7);
    resource->path.group[7] = '\0';

    return resource;
}

void al_destroy_resource(ALResource resource)
{
    if (resource->path.name != NULL)
    {
        free(resource->path.name);
        resource->path.name = NULL;
    }
    if (resource->path.path != NULL)
    {
        free(resource->path.path);
        resource->path.path = NULL;
    }

    free(resource);
    resource = NULL;
}
